#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define MAX_ITENS    200

#define TAM_ARQNOME  128
#define TAM_NOME      41
#define TAM_END      121
#define TAM_FONE      16
#define TAM_EMAIL     21
#define TAM_CIDADE    11
#define TAM_CEP       10
#define TAM_ESTADO     3
#define TAM_NIVER     10

struct endereco {
  char nome[TAM_NOME];
  char end[TAM_END];
  char fone[TAM_FONE];
  char email[TAM_EMAIL];
  char cidade[TAM_CIDADE];
  char cep[TAM_CEP];
  char estado[TAM_ESTADO];
  char niver[TAM_NIVER];
};


/* Esvazia buffer de entrada de stream */
void ciflushin(FILE *stream)
{
  int c;

  while ((c = fgetc(stream)) != EOF && c != '\n');
}

/* Mesmo que fgets(), mas retira  do buffer o caracter '\n' final que
   fgets()  insere no  buffer de  entrada. Tambem  assegura  que buffer
   interno foi esvaziado.
*/

void cigets (char buffer[], int size, FILE *stream)
{
  int i;
  
  /* elimina '\n' inserido por fgets() */
  if (fgets(buffer, size, stream) != NULL) {
    if (strlen(buffer) != (size - 1)) {
      for (i = strlen(buffer); buffer[i] != '\n'; i--);
      buffer[i] = '\0';
    }
    else
      ciflushin(stream);
  }

}


/* Le um item da agenda */
struct endereco leItem ()
{

  struct endereco item = {"", "", "", "", "", "", "", ""};

  /* Obtem os dados de um item da agenda */
  printf("NOME: ");
  cigets(item.nome, TAM_NOME, stdin);

  if (strlen(item.nome)) {
    printf("ENDERECO: ");
    cigets(item.end, TAM_END, stdin);
    
    printf("FONE: ");
    cigets(item.fone, TAM_FONE, stdin);
    
    printf("E-MAIL: ");
    cigets(item.email, TAM_EMAIL, stdin);
    
    printf("CIDADE: ");
    cigets(item.cidade, TAM_CIDADE, stdin);
    
    printf("ESTADO: ");
    cigets(item.estado, TAM_ESTADO, stdin);
    
    printf("CEP: ");
    cigets(item.cep, TAM_CEP, stdin);

    printf("\n\n%%%%%%%%%%%%%%%%%%%%%%\n\n");
  }

  return item;
}


void imprimeItem (struct endereco item)
{
    printf("NOME: %s\n", item.nome);
    printf("ENDERECO: %s\n", item.end);
    printf("FONE: %s\n", item.fone);
    printf("E-MAIL: %s\n", item.email);
    printf("CIDADE: %s\n", item.cidade);
    printf("ESTADO: %s\n", item.estado);
    printf("CEP: %s\n", item.cep);
    printf("-----------------------\n");
}


void imprimeAgenda(struct endereco agenda[])
{
  int i;

  printf("\n\n=====================\n\n");

  for (i=0; strlen(agenda[i].nome); i++)
    imprimeItem(agenda[i]);

  printf("\n\n");
}



main ()
{

  int i, err;

  struct endereco agenda[MAX_ITENS],
                  ragenda[MAX_ITENS];
  char arquivo[] = "agenda_01.dat";
  int nitens;
  FILE *fp;
 
  fp = fopen (arquivo, "w+");
  
  if (fp == NULL)
    printf("Erro ao abrir arquivo %s\n", arquivo);
  else {
    nitens = 0;
    do {
      agenda[nitens] = leItem();
    } while (strlen(agenda[nitens++].nome));
    
    --nitens;

    printf("\n\nGravando agenda no arquivo \"%s\" .... ", arquivo);
    
    for (i=0, err=1; i < nitens && err > 0; i++) {
      err = fprintf(fp, "%s %s %s %s %s %s %s\n", agenda[i].nome, agenda[i].end, 
		    agenda[i].fone, agenda[i].email, agenda[i].cidade, 
		    agenda[i].estado, agenda[i].cep);
    }
    if (err < 0)
      printf("Erro na gravacao da agenda !!!!!\n\n");
    else {
      printf("OK!!!!\n\n");
      
      /* Testando gravacao */
      fflush(fp);
      fclose(fp);
      fp = fopen (arquivo, "r");
      
      printf("\n\nLendo agenda do arquivo \"%s\" ....\n\n ", arquivo);
      
      for (i=0, err=0; err != EOF ; i++) {
	err = fscanf(fp, "%s %s %s %s %s %s %s", ragenda[i].nome, 
		     ragenda[i].end, ragenda[i].fone, ragenda[i].email,
		     ragenda[i].cidade, ragenda[i].estado, ragenda[i].cep);
      }

      if (err == EOF)
	imprimeAgenda(ragenda);
      else
	printf("Erro na leitura do arquivo %s\n", arquivo);

      fclose(fp);     /* fecha arquivo */
    } /* FIM (fwrite() != nitens) */
  }  /* FIM (fp == NULL) */
}

